#include <stdio.h>
#include <stdlib.h>

#define DEBUG
#define LLLL 76
#define RRRR 82

struct ant {
	unsigned int x;
	unsigned int dir;
	unsigned int xstart;
};

struct ants {
	struct ant *a;
	unsigned int size;
	unsigned int isl;
	unsigned int isr;
	unsigned int la;
	unsigned int lz;
	unsigned int ra;
	unsigned int rz;
	unsigned int sizeof_world;
};

void ants_init(struct ants *a)
{
/*

#ifdef DEBUG
	printf("%s \n",__func__);
#endif
*/
	a->size = 0;
	a->isl = 0;
	a->isr = 0;
	a->la = ~0;
	a->lz = 0;
	a->ra = ~0;
	a->rz = 0;
	a->sizeof_world = 0;
}

struct ant* getant(struct ants *a, int id)
{
	return &a->a[id];
}

void ants_load(struct ants *a,int x, int dir)
{

#ifdef DEBUG
	printf("%s %i \n",__func__, x);
#endif

	struct ant *f;
	f = getant(a,a->size);
	f->x=x;
	f->dir=dir;

	if (dir == LLLL)
		{if (a->isl == 0){a->la = a->size; a->isl = 1;}
		a->lz = a->size;

		}
	else if (dir == RRRR)
		{if (a->isr == 0){a->ra = a->size;a->isr = 1;}
		a->rz = a->size;
		
		}
	else {exit(-1);}


	a->size++;
}

void tryend()
{

if (feof(stdin)){
exit(0);
}
}


void gosolve(struct ants *a, unsigned int nowtime)
{
#ifdef DEBUG
	printf("Solvujem %u %u %u %u %u %u\n", a->isl, a->la, a->lz, a->isr, a->ra, a->rz);
#endif


	if (!a->isl) {
		unsigned int min=~0;
		int i;
		for (i = a->ra; i <= a->rz; i++){
			struct ant *f;
			f = getant(a,i);
			if (f->dir == RRRR) {
			if (min > f->x)
				min = f->x;
			}
		}
		printf("\n\nSOLUTION:%u\n\n", a->sizeof_world - nowtime + min  );
		return;
	}

	if (!a->isr) {
		unsigned int min=0;
		int i;
		for (i = a->la; i <= a->lz; i++){
			struct ant *f;
			f = getant(a,i);
			if (f->dir == LLLL) {
			if (min < f->x)
				min = f->x;
			}
		}
		printf("The last ant will fall down in %u seconds - started at \n",  nowtime + min  );
		return;
	}

	

}

void soll(struct ants *a, int n)
{

	int i;

#ifdef DEBUG
/*	printf("Loadm");*/
#endif

	for (i = 0; i < n; i++) {

	unsigned int x;
	unsigned int dir;
	char c;	


	scanf("%i %c", &x, &c);
	dir = c;
#ifdef DEBUG
/*	printf("Ssss %u %i\n", x, c);*/
#endif

	ants_load(a, x, dir);
	}

	#ifdef DEBUG
	printf("loaddeeed\n");
	#endif
	gosolve(a,0);
}


void solve()
{
	int xsize, antsn;
	xsize = ~0;
	scanf("%i %i", &xsize, &antsn);
	if (xsize == ~0)
		exit(0);

	struct ant mravc[100000];
	struct ants a;
	a.a=&mravc;

/*
#ifdef DEBUG
	printf("SOlve %i %i\n", xsize, antsn);
#endif
*/
	ants_init(&a);
	a.sizeof_world = xsize;
	soll(&a, antsn);
	/*

	solv(NULL, xsize, antsn);
	tryend();
*/
}

int main()
{

while(1) {


	solve();



	tryend();

}

}
